/*
 * listeEmplacements->cpp
 *
 *  Created on: 10 avr. 2011
 *      Author: sarterm
 */

#include "listeEmplacements.h"

ListeEmplacements::ListeEmplacements() {
    listeEmplacements = new QStringList();
    listeFiltres = new QStringList();
    listeSelection = new QList<bool>();
}

ListeEmplacements::~ListeEmplacements() {
    delete listeEmplacements;
    delete listeFiltres;
    delete listeSelection;
}

int ListeEmplacements::rowCount(const QModelIndex &parent) const {
    return listeEmplacements->size();
}

int ListeEmplacements::columnCount(const QModelIndex &parent) const {
    return 2;
}

QVariant ListeEmplacements::headerData(int section, Qt::Orientation orientation, int role) const {
    if (role != Qt::DisplayRole) {
        return QVariant();
    }
    switch(section) {
        case 0:
            return QString("Filtre");
        case 1:
            return QString("Chemin");
        default:
            break;
    }
    return QVariant();
}

QVariant ListeEmplacements::data(const QModelIndex &index, int role) const {
    if (role != Qt::DisplayRole) {
        return QVariant();
    }
    int ligne = index.row();
    switch(index.column()) {
        case 0:
            return listeFiltres->at(ligne);
        case 1:
            return listeEmplacements->at(ligne);
        default:
            break;
    }
    return QVariant();
}


Qt::ItemFlags ListeEmplacements::flags(const QModelIndex & index) const {
    return QAbstractItemModel::flags(index);
}

void ListeEmplacements::ajouterEmplacement(QString path, QString filtre) {
    for (int i = 0; i < listeEmplacements->size(); i++) {
        if (listeEmplacements->at(i) == path &&
            listeFiltres->at(i) == filtre) {
            return;
        }
    }
    beginInsertRows(QModelIndex(), listeEmplacements->size(), listeEmplacements->size());
    listeEmplacements->append(path);
    listeFiltres->append(filtre);
    listeSelection->append(false);
    endInsertRows();
    dataChanged(QAbstractListModel::index(listeEmplacements->size() - 1, 0), QAbstractListModel::index(listeEmplacements->size() - 1, columnCount() - 1));
}

void ListeEmplacements::supprimerEmplacement(int ligne) {
    beginRemoveRows(QModelIndex(), ligne, ligne);
    listeEmplacements->removeAt(ligne);
    listeFiltres->removeAt(ligne);
    listeSelection->removeAt(ligne);
    endRemoveRows();
    emit dataChanged(QAbstractListModel::index(ligne, 0), QAbstractListModel::index(listeEmplacements->size() - 1, columnCount() - 1));
}

QString ListeEmplacements::getPath(int ligne) {
    return listeEmplacements->at(ligne);
}

QString ListeEmplacements::getFiltre(int ligne) {
    return listeFiltres->at(ligne);
}

bool ListeEmplacements::getSelection(int ligne) {
    return listeSelection->at(ligne);
}

void ListeEmplacements::setSelection(int ligne, bool selected) {
    listeSelection->replace(ligne, selected);
}
