/*
 * parametres.cpp
 *
 *  Created on: 10 avr. 2011
 *      Author: sarterm
 */

#include "parametres.h"

QSettings* Parametres::fichierIni = NULL;

QString Parametres::getEmplacementPath(int ligne) {
    if (fichierIni == NULL) {
        charger();
    }
    return fichierIni->value(QString() + "Emplacement_" + QString::number(ligne, 10) + "/path").toString();
}

QString Parametres::getEmplacementFiltre(int ligne) {
    if (fichierIni == NULL) {
        charger();
    }
    return fichierIni->value(QString() + "Emplacement_" + QString::number(ligne, 10) + "/filtre").toString();
}

bool Parametres::isEmplacementSelected(int ligne) {
    if (fichierIni == NULL) {
        charger();
    }
    return fichierIni->value(QString() + "Emplacement_" + QString::number(ligne, 10) + "/selected").toBool();
}

void Parametres::setEmplacement(int ligne, QString path, QString filtre, bool selected) {
    if (fichierIni == NULL) {
        charger();
    }
    fichierIni->setValue(QString() + "Emplacement_" + QString::number(ligne, 10) + "/path", path);
    fichierIni->setValue(QString() + "Emplacement_" + QString::number(ligne, 10) + "/filtre", filtre);
    fichierIni->setValue(QString() + "Emplacement_" + QString::number(ligne, 10) + "/selected", selected);
    fichierIni->sync();
}

void Parametres::deleteEmplacement(int ligne) {
    if (fichierIni == NULL) {
        charger();
    }
    fichierIni->remove("Emplacement_" + ligne);
    fichierIni->sync();
}

void Parametres::charger() {
    delete fichierIni;
    fichierIni = new QSettings("WallpaperRotator2.ini", QSettings::IniFormat);
}

int Parametres::getIntervalle() {
    if (fichierIni == NULL) {
        charger();
    }
    return fichierIni->value("Options/timer").toInt();
}

void Parametres::setIntervalle(int intervalle) {
    if (fichierIni == NULL) {
        charger();
    }
    fichierIni->setValue("Options/timer", intervalle);
    fichierIni->sync();
}

Parametres::STYLE Parametres::getStyle() {
    // Lecture de la valeur dans la base de registre
    QSettings settings("HKEY_CURRENT_USER\\Control Panel\\Desktop", QSettings::NativeFormat);
    QString wallpaperStyle = settings.value("WallpaperStyle").toString();
    QString tileWallpaper = settings.value("TileWallpaper").toString();

    if (wallpaperStyle == "0" &&
        tileWallpaper == "0") {
        return CENTERED;
    }
    if (wallpaperStyle == "0" &&
        tileWallpaper == "1") {
        return TILED;
    }
    if (wallpaperStyle == "2" &&
        tileWallpaper == "0") {
        return STRETCHED;
    }
    if (wallpaperStyle == "6" &&
        tileWallpaper == "0") {
        return ADJUST;
    }
    if (wallpaperStyle == "10" &&
        tileWallpaper == "0") {
        return FILL;
    }
    return UNDEF;
}

void Parametres::setStyle(Parametres::STYLE style) {
    QString wallpaperStyle = "";
    QString tileWallpaper = "";
    switch(style) {
        case CENTERED:
            wallpaperStyle = "0";
            tileWallpaper = "0";
            break;
        case TILED:
            wallpaperStyle = "0";
            tileWallpaper = "1";
            break;
        case STRETCHED:
            wallpaperStyle = "2";
            tileWallpaper = "0";
            break;
        case ADJUST:
            wallpaperStyle = "6";
            tileWallpaper = "0";
            break;
        case FILL:
            wallpaperStyle = "10";
            tileWallpaper = "0";
            break;
        default:
            return;
    }

    // Sauvegarde de la nouvelle valeur dans la base de registre
    QSettings settings("HKEY_CURRENT_USER\\Control Panel\\Desktop", QSettings::NativeFormat);
    settings.setValue("WallpaperStyle", wallpaperStyle);
    settings.setValue("TileWallpaper", tileWallpaper);
    settings.sync();

    // Notification de la modification
    SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, NULL, SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
}

bool Parametres::isActive() {
    if (fichierIni == NULL) {
        charger();
    }
    return fichierIni->value("Options/active").toBool();
}

void Parametres::setActive(bool active) {
    if (fichierIni == NULL) {
        charger();
    }
    fichierIni->setValue("Options/active", active);
    fichierIni->sync();
}
