/*
 * rotator.cpp
 *
 *  Created on: 10 avr. 2011
 *      Author: sarterm
 */

#include "rotator.h"

Rotator::Rotator() : QObject() {
    timer = new QTimer();
    connect(timer, SIGNAL(timeout()), this, SLOT(changerWallpaper()));
}

Rotator::~Rotator() {
    delete timer;
}

void Rotator::changerWallpaper() {
    LARGE_INTEGER hiPerfCounter;
    if (filesCount == 0) {
        // TODO : message d'erreur + arrt et mise  jour menu
        return;
    }
    else if (filesCount == 1) {
        // TODO : message d'erreur + arrt et mise  jour menu
        return;
    }
    // On a pass tous les fonds d'cran une fois, on recommence
    if (randFilesCount == 0) {
        randFilesCount = filesCount;
    }
    QueryPerformanceCounter(&hiPerfCounter);
    currentFile = hiPerfCounter.LowPart % randFilesCount;

    // Dplacement du fichier dans la liste de travail : on le permute avec le dernier lment et on dcrmente le nombre de fonds d'cran restant  passer
    QString wallpaper = filesList.at(currentFile);
    filesList.replace(currentFile, filesList.at(randFilesCount - 1));
    filesList.replace(randFilesCount - 1, wallpaper);
    randFilesCount--;

    wallpaper.replace(QChar('/'), QChar('\\'));
    // Application du nouveau fond d'cran
    int res = SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, (LPSTR) wallpaper.utf16(), SPIF_UPDATEINIFILE | SPIF_SENDWININICHANGE);
    if (!res) {
        // TODO : message d'erreur
        return;
    }
}

void Rotator::demarrer() {
    changerWallpaper();
    timer->start(Parametres::getIntervalle()*1000);
}

void Rotator::arreter() {
    timer->stop();
}

void Rotator::setTimer(int secondes) {
    timer->setInterval(secondes*1000);
    Parametres::setIntervalle(secondes);
}

void Rotator::listerFichiers(ListeEmplacements *emplacements) {
    filesList.clear();
    filesCount = 0;
    randFilesCount = 0;

    for (int j = 0; j < emplacements->rowCount(); j++) {
        if (!emplacements->getSelection(j)) {
            continue;
        }
        QDir repertoireSource = emplacements->getPath(j);
        QStringList filters;
        filters.append(emplacements->getFiltre(j));
        repertoireSource.setNameFilters(filters);
        QFileInfoList listeFichiers = repertoireSource.entryInfoList();
        filesCount = listeFichiers.size();
        for (int i = 0; i < filesCount; i++) {
            filesList.append(listeFichiers.at(i).filePath());
        }
    }
    filesCount = filesList.size();
    randFilesCount = filesCount;
}
