#ifndef WALLPAPERROTATOR2_H
#define WALLPAPERROTATOR2_H

#include <QtGui/QWidget>
#include <QMenu>
#include <QSystemTrayIcon>
#include <QMessageBox>
#include <QCloseEvent>
#include <QFileDialog>
#include <QDesktopServices>
#include <QDebug>

#include "parametres.h"
#include "intervalleperso.h"
#include "filtre.h"
#include "rotator.h"
#include "listeemplacements.h"
#include "ui_wallpaperrotator2.h"

class WallpaperRotator2 : public QWidget
{
    Q_OBJECT

public:
    WallpaperRotator2(QWidget *parent = 0);
    ~WallpaperRotator2();

protected:
    void closeEvent(QCloseEvent *event);

private:
    Ui::WallpaperRotator2Class ui;
    QMenu* trayMenu;
    QSystemTrayIcon* trayIcon;
    QWidget* widgetMinimized;
    ListeEmplacements* emplacements;
    Rotator* rotator;

    void creerTrayMenu();

private slots:
    void on_trayIconAction(QSystemTrayIcon::ActivationReason reason);
    void on_changerIntervalle(QAction* action);
    void on_changerStyle(QAction* action);
    void on_changerEmplacement(QAction* action);
    void on_ajouterEmplacement();
    void on_supprimerEmplacement();
    void on_activer(bool activer);
};

#endif // WALLPAPERROTATOR2_H
